#include "..\inc\gauges.h"
#include "..\inc\eventid.h"
#include "..\inc\dragonflight.h"
#include "..\inc\fssound.h"
#include "stdio.h"
#include "stdlib.h"
#include "string.h"
#include "dfd_garnav.h"

/***************** Global functions ***********************/

void FSAPI	add_imagedata_to_listelement(PELEMENT_HEADER	pelement,UINT32	pos_element,FLAGS image_flags);
void FSAPI	remove_imagedata_from_listelement(PELEMENT_HEADER	pelement,UINT32	pos_element,FLAGS image_flags);

PELEMENT_STATIC_IMAGE	pstat=NULL;	//Mouse background data

#define GAUGE_CHARSET						DEFAULT_CHARSET
#define GAUGE_WEIGHT_DEFAULT				FW_NORMAL
#define GAUGE_FONT_ARIAL					"ARIAL"
#define GAUGE_FONT_COURIER					"COURIER_NEW"
#define GAUGE_FONT_TIMES					"TIMES_NEW_ROMAN"
#define GAUGE_FONT_HELV						"HELVETICA"
#define GAUGE_FONT_QUARTZ					"QUARTZ"

/******** Token variable pointers and local representative variables ********/

MODULE_VAR	time1 = {TICK18};

//FS2000 default electrical systems

MODULE_VAR avionics_circuit_on = {AVIONICS_CIRCUIT_ON};
UINT32 avionics_on = 0;

MODULE_VAR navlights_on = {NAV_LIGHTS};
UINT32 lights_on = 0;

//Navigation

MODULE_VAR	omi = {MARKER_BEACON_STATE};
UINT32 omi_marker = 0;

MODULE_VAR localiser = {HSI_SIGNAL_LOCALISER};
UINT32 hsi_loc_sig = 0;

//VOR1

MODULE_VAR	gflag = {VOR1_GS_FLAG};
UINT32 gs_active = 0;

MODULE_VAR	deviation = {VOR1_NEEDLE};
SINT32 vor1_loc = 0;

MODULE_VAR	heading = {VOR1_OBI};
UINT32 vor1_hdg = 0;

MODULE_VAR	glideslope = {VOR1_GS_NEEDLE};
SINT32 vor1_gs = 0;

MODULE_VAR	nav1_bearing = {NAV1_VOR_RADIAL};
UINT32 nav1_brg = 0;

MODULE_VAR	tf_flag = {VOR1_TF_FLAG};
SINT32 vor1_tf = 0;

MODULE_VAR	vor1_str = {VOR1_SIGNAL_STRENGTH};
UINT32 vor1_sig = 0;

MODULE_VAR	vor1_bc = {VOR1_BACK_COURSE_FLAGS};

//VOR2

MODULE_VAR	deviation2 = {VOR2_NEEDLE};
UINT32 vor2_loc = 0;

MODULE_VAR	heading2 = {VOR2_OBI};
UINT32 vor2_hdg = 0;

MODULE_VAR	nav2_bearing = {NAV2_VOR_RADIAL};
UINT32 nav2_brg = 0;

MODULE_VAR	tf_flag2 = {VOR2_TF_FLAG};
UINT32 vor2_tf = 0;

MODULE_VAR	vor2_str = {VOR2_SIGNAL_STRENGTH};
UINT32 vor2_sig = 0;

//ADF

MODULE_VAR adf_str = {ADF_SIGNAL_STRENGTH};
UINT32 adf_sig = 0;

MODULE_VAR adf_dev = {ADF_NEEDLE};
FLOAT64 adf_needle = 0;

//Aircraft

MODULE_VAR	nose_hdg = {PLANE_HEADING_DEGREES_MAGNETIC};
UINT32 plane_hdg = 0;



//****** Subgauges *************//

#define		GAUGE_NAME			"gi102a\0"
#define		GAUGEHDR_VAR_NAME	gaugehdr_gi102
#define		GAUGE_W				38

#include "subgauges\gi102a.c"


#define		GAUGE_NAME			"gi106a\0"
#define		GAUGEHDR_VAR_NAME	gaugehdr_gi106
#define		GAUGE_W				38

#include "subgauges\gi106a.c"

//--------------------------------------------------------------
// Gauge table entries

GAUGE_TABLE_BEGIN()
	GAUGE_TABLE_ENTRY(&gaugehdr_gi102)
	GAUGE_TABLE_ENTRY(&gaugehdr_gi106)
GAUGE_TABLE_END()
