char p0_gauge_name[]		= GAUGE_NAME;
extern PELEMENT_HEADER		p0_list;
extern MOUSERECT			p0_mouse_rect[];
GAUGE_CALLBACK				p0_update;
GAUGE_HEADER_FS700(GAUGE_W, p0_gauge_name, &p0_list, p0_mouse_rect, p0_update, 0,0,0 );

FAILURE_RECORD	p0_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_ZERO},
	{FAIL_NONE, FAIL_ACTION_NONE}
};


MOUSE_FUNCTION p0_switch_mcb;			//Mouse click to turn switch on and off

MOUSE_BEGIN( p0_mouse_rect, 0, 0, 0 )

    MOUSE_CHILD_FUNCT( 0, 0, 43, 73, CURSOR_UPARROW, MOUSE_LEFTSINGLE, p0_switch_mcb)

MOUSE_END

UINT32 p0_sw = 0;					//Variable to track position of switch

//Switch on bitmap as an icon.
//This icon must be invisible when loading

MAKE_ICON(		p0_on_icon,
				PANEL_SW_ON,
				NULL,
				NULL,
				erase | transparent | hidden,
				0,
				0,0,
				MODULE_VAR_NONE, NULL,
				ICON_SWITCH_TYPE_SET_CUR_ICON,
				1,
				0,
				0 )

PELEMENT_HEADER		p0_plist1[] =
{
	&p0_on_icon.header,
	NULL
};

//Switch off bitmap as an icon. This is the default position
//when loading so the bitmap is visible

MAKE_ICON(		p0_off_icon,
				PANEL_SW_OFF,
				&p0_plist1,
				NULL,
				erase | transparent,
				0,
				0,0,
				MODULE_VAR_NONE, NULL,
				ICON_SWITCH_TYPE_SET_CUR_ICON,
				1,
				0,
				0 )

PELEMENT_HEADER		p0_plist2[] =
{
	&p0_off_icon.header,
	NULL
};

//Switch off bitmap is the background.
//In this case I have made it completely transparent
//but normally it would be a painted part of your gauge.

MAKE_STATIC (	p0_off_static,
				PANEL_SW_BG,
				&p0_plist2,
				NULL,
				erase | transparent,
				0,
				0,0 )

PELEMENT_HEADER	p0_list	= &p0_off_static.header;

//Register the click sound - see \gauge sound\fssound folder for more info
//and ways to control the sound volume and position in the stereo field.
//Done this way as an external resource the user may change the sound to suit 
//his own gauges. You must supply both the wav file and fssound.dll with the 
//finished gauge and tell the user where to put them in the fs\sound and 
//fs\modules folders.

MFSSoundFileVars(click0, "Sound\\360smtog.wav");


//---------------------------------------------------------------------------
BOOL FSAPI p0_switch_mcb( PPIXPOINT relative_point, FLAGS32 mouse_flags )
{

//Toggle the switch bitmap - see PANEL_SERVICE_PRE_UPDATE below.

	if (p0_sw == 0) p0_sw = 1;
	else p0_sw = 0;

//Play the click sound.

	MFSSoundFilePlay(click0, FALSE);

//Show and hide sub-panel 1 - NOTE: window00 is KEY_PANEL_1!!!!!!
//The KEY_PANEL event is a toggle event so it automatically switches on and off.

	trigger_key_event(KEY_PANEL_2,0);

	return FALSE;
}
//---------------------------------------------------------------------------
void FSAPI	p0_update (PGAUGEHDR pgauge, int service_id, UINT32 extra_data)
{
	switch(service_id)
	{

/* "install_routine()" */

		case    PANEL_SERVICE_PRE_INSTALL:

//Register the click sound with FS when loading the panel

		MFSSoundFileRegister(click0);

		break;

/* "initialize_routine()" */

		case    PANEL_SERVICE_PRE_INITIALIZE:
		break;

/* "update_routine()" */

		case    PANEL_SERVICE_PRE_UPDATE:

//Now show and hide the switch bitmaps by showing and hiding the icons

		if (p0_sw == 1) 
		{		
			SHOW_LISTELEMENT(pgauge->elements_list[0],2);
			HIDE_LISTELEMENT(pgauge->elements_list[0],1);
		}
		else
		{		
			SHOW_LISTELEMENT(pgauge->elements_list[0],1);
			HIDE_LISTELEMENT(pgauge->elements_list[0],2);
		}
			
		break;

/* "draw_routine()" */

		case    PANEL_SERVICE_PRE_DRAW:
		break;

/* "kill_routine()" */

		case    PANEL_SERVICE_PRE_KILL:

//Unregister the sound when unloading the panel

		MFSSoundUnregister(click0);

		break;
	}

}

/////////////////////////////////////////////////////////////////////////////
#undef GAUGE_NAME
#undef GAUGEHDR_VAR_NAME
#undef GAUGE_W

