#include "..\inc\gauges.h"
#include "..\inc\eventid.h"
#include "..\inc\dragonflight.h"
#include "..\inc\fssound.h"
#include "stdio.h"
#include "stdlib.h"
#include "string.h"
#include "1900dpri.h"

/***************** Global functions ***********************/

void FSAPI	add_imagedata_to_listelement(PELEMENT_HEADER	pelement,UINT32	pos_element,FLAGS image_flags);
void FSAPI	remove_imagedata_from_listelement(PELEMENT_HEADER	pelement,UINT32	pos_element,FLAGS image_flags);

#define GAUGE_CHARSET						DEFAULT_CHARSET
#define GAUGE_WEIGHT_DEFAULT				FW_NORMAL
#define GAUGE_FONT_ARIAL					"ARIAL"
#define GAUGE_FONT_COURIER					"COURIER_NEW"
#define GAUGE_FONT_TIMES					"TIMES_NEW_ROMAN"
#define GAUGE_FONT_HELV						"HELVETICA"
#define GAUGE_FONT_QUARTZ					"QUARTZ"

/******** Token variable pointers and local representative variables ********/

MODULE_VAR avlights = {PANEL_LIGHTS};
UINT32 panel_lights = 0;

MODULE_VAR	curr_vsi = {VERTICAL_SPEED};
UINT32 vsi = 0;

MODULE_VAR	curr_asi = {AIRSPEED};
UINT32 ias = 0;

MODULE_VAR	baro_height = {ALT_FROM_BAROMETRIC_PRESSURE};
UINT32 altitude = 0;

MODULE_VAR hour = {CLOCK_HOUR};
MODULE_VAR minute = {CLOCK_MINUTE};
MODULE_VAR second = {CLOCK_SECOND};

//***********************************************************

UINT32	attitude_lights = 0;
UINT32	alt_lights_on = 0;			//Lights
UINT32	asi_lights_on = 0;			//Lights
UINT32	vsi_lights_on = 0;			//Lights
UINT32	clk_lights_on = 0;			//Lights


#define		GAUGE_NAME			"vsi\0"
#define		GAUGEHDR_VAR_NAME	gaugehdr_vsi
#define		GAUGE_W				38

#include "subgauges\\vsi.c"

#define		GAUGE_NAME			"asi\0"
#define		GAUGEHDR_VAR_NAME	gaugehdr_asi
#define		GAUGE_W				38

#include "subgauges\\asi.c"

#define		GAUGE_NAME			"alt\0"
#define		GAUGEHDR_VAR_NAME	gaugehdr_alt
#define		GAUGE_W				38

#include "subgauges\\alt.c"

#define		GAUGE_NAME			"clock\0"
#define		GAUGEHDR_VAR_NAME	gaugehdr_clock
#define		GAUGE_W				38

#include "subgauges\\clock.c"

#define		GAUGE_NAME			"attitude\0"
#define		GAUGEHDR_VAR_NAME	gaugehdr_attitude
#define		GAUGE_W				38

#include "subgauges\\attitude.c"

//--------------------------------------------------------------
// Gauge table entries

GAUGE_TABLE_BEGIN()
	GAUGE_TABLE_ENTRY(&gaugehdr_vsi)
	GAUGE_TABLE_ENTRY(&gaugehdr_asi)
	GAUGE_TABLE_ENTRY(&gaugehdr_alt)
	GAUGE_TABLE_ENTRY(&gaugehdr_clock)
	GAUGE_TABLE_ENTRY(&gaugehdr_attitude)
GAUGE_TABLE_END()
