//REPLACE attitude WITH GAUGENAME

char attitude_gauge_name[]		= GAUGE_NAME;
extern PELEMENT_HEADER		attitude_list;
extern MOUSERECT			attitude_mouse_rect[];
GAUGE_CALLBACK				attitude_update;
GAUGE_HEADER_FS700(GAUGE_W, attitude_gauge_name, &attitude_list, attitude_mouse_rect, attitude_update, 0,0,0 );

FAILURE_RECORD	attitude_fail[] =
{
	{FAIL_SYSTEM_VACUUM, FAIL_ACTION_FREEZE},
	{FAIL_GAUGE_ATTITUDE, FAIL_ACTION_FREEZE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};

SINT32 attitude_comp = 0;		//Adjust horizon

MOUSE_FUNCTION attit_up_mcb;
MOUSE_FUNCTION attit_dn_mcb;

MOUSE_BEGIN( attitude_mouse_rect, 0, 0, 0 )
    MOUSE_CHILD_FUNCT( 181, 189, 48, 88, CURSOR_DOWNARROW, MOUSE_LEFTSINGLE, attit_dn_mcb)
    MOUSE_CHILD_FUNCT( 229, 189, 48, 88, CURSOR_UPARROW, MOUSE_LEFTSINGLE, attit_up_mcb)
MOUSE_END

SPRITE_UPDATE_CALLBACK	attitude_pitch_limit_sprite;
SPRITE_UPDATE_CALLBACK	attitude_pitch_limit_night_sprite;
NEEDLE_UPDATE_CALLBACK attitude_needle_cb;

#define	ATTITUDE_PITCH_LIMIT		40.0		// stop at 40 degrees


NONLINEARITY attitude_needle_nl[] =
{
	{{187,	 223},	   -5, 0},
	{{189,	 218},	   -4, 0},
	{{191,	 215},	   -3, 0},
	{{193,	 211},	   -2, 0},
	{{195,	 207},	   -1, 0},
	{{196,	 202},	   0, 0},
	{{202,	 201},	   5, 0},
	{{205,	 199},	   4, 0},
	{{209,	 197},	   3, 0},
	{{213,	 196},	   2, 0},
	{{217,	 193},	   1, 0},
};


MAKE_NEEDLE(    attitude_adjust_needle,
                ATTIT_SET,
                NULL,
                NULL,
				erase | transparent | anti_alias,
                0,
                236, 239,
				30, 29,
				MODULE_VAR_NONE,
				attitude_needle_cb,
                attitude_needle_nl,
                0 )

PELEMENT_HEADER		attitude_plist1[] =
{
	&attitude_adjust_needle.header,
	NULL
};

//**********************Day

MAKE_ICON(		attitude_bars_icon,
				ATTIT_BARS,
				&attitude_plist1,
				NULL,
				erase | transparent,
				0,
				49,49,
				MODULE_VAR_NONE, NULL,
				ICON_SWITCH_TYPE_SET_CUR_ICON,
				1,
				0,
				0 )

PELEMENT_HEADER		attitude_plist2[] =
{
	&attitude_bars_icon.header,
	NULL
};


MAKE_SPRITE(	attitude_roll_sprite,
				ATTIT_ROLL,
				&attitude_plist2,
				&attitude_fail,
                transparent | erase,
				0,
				49,  49,          //mask posn
				128, 128,          //card posn
				1.0, 1.0,
				MODULE_VAR_NONE, NULL, 0.0,
				MODULE_VAR_NONE, NULL, 0.0,
				ATTITUDE_INDICATOR_BANK_DEGREES, NULL, -1 )

PELEMENT_HEADER		attitude_plist3[] =
{
	&attitude_roll_sprite.header,
	NULL
};

MAKE_SPRITE(	attitude_pitch_sprite,
				ATTIT_PITCH,
				&attitude_plist3,
				&attitude_fail,
                transparent | erase,
				0,
				49, 49,
				128,128,
				1.0, 1.0, //card size about centre
				MODULE_VAR_NONE, NULL, 0.0,
				ATTITUDE_INDICATOR_PITCH_DEGREES, attitude_pitch_limit_sprite, 2.0,
				ATTITUDE_INDICATOR_BANK_DEGREES, NULL, -1 )

PELEMENT_HEADER		attitude_plist4[] =
{
	&attitude_pitch_sprite.header,
	NULL
};


//**********************Night

MAKE_ICON(		attitude_bars_night_icon,
				ATTIT_BARS,
				&attitude_plist4,
				NULL,
				erase | transparent | bright,
				0,
				49,49,
				MODULE_VAR_NONE, NULL,
				ICON_SWITCH_TYPE_SET_CUR_ICON,
				1,
				0,
				0 )

PELEMENT_HEADER		attitude_plist5[] =
{
	&attitude_bars_night_icon.header,
	NULL
};


MAKE_SPRITE(	attitude_roll_night_sprite,
				ATTIT_ROLL,
				&attitude_plist5,
				&attitude_fail,
                transparent | erase | bright,
				0,
				49,  49,          //mask posn
				128, 128,          //card posn
				1.0, 1.0,
				MODULE_VAR_NONE, NULL, 0.0,
				MODULE_VAR_NONE, NULL, 0.0,
				ATTITUDE_INDICATOR_BANK_DEGREES, NULL, -1 )

PELEMENT_HEADER		attitude_plist6[] =
{
	&attitude_roll_night_sprite.header,
	NULL
};

MAKE_SPRITE(	attitude_pitch_night_sprite,
				ATTIT_PITCH,
				&attitude_plist6,
				&attitude_fail,
                transparent | erase | bright,
				0,
				49, 49,
				128,128,
				1.0, 1.0, //card size about centre
				MODULE_VAR_NONE, NULL, 0.0,
				ATTITUDE_INDICATOR_PITCH_DEGREES, attitude_pitch_limit_night_sprite, 2.0,
				ATTITUDE_INDICATOR_BANK_DEGREES, NULL, -1 )

PELEMENT_HEADER		attitude_plist7[] =
{
	&attitude_pitch_night_sprite.header,
	NULL
};

MAKE_STATIC(	attitude_background,
				ATTIT_BG,
				&attitude_plist7,
				NULL,
                transparent | erase,
				0,
				{0,0} )

PELEMENT_HEADER		attitude_list	= &attitude_background.header;

//---------------------------------------------------------------------------
FLOAT64 FSAPI attitude_needle_cb (PELEMENT_NEEDLE pelement )
{
	FLOAT64	val = pelement->source_var.var_value.n;

	return attitude_comp;
}
//---------------------------------------------------------------------------
BOOL FSAPI attit_up_mcb( PPIXPOINT relative_point, FLAGS32 mouse_flags )
{
	if (attitude_comp != 5) attitude_comp ++;
	return FALSE;
}
//---------------------------------------------------------------------------
BOOL FSAPI attit_dn_mcb( PPIXPOINT relative_point, FLAGS32 mouse_flags )
{
	if (attitude_comp != -5) attitude_comp --;
	return FALSE;
}
//---------------------------------------------------------------------------
FLOAT64	FSAPI	attitude_pitch_limit_sprite(PELEMENT_SPRITE pelement)
{

	FLOAT64 val=pelement->source_var_y.var_value.n;

	if( val > ATTITUDE_PITCH_LIMIT )
		val =  ATTITUDE_PITCH_LIMIT;
	else if( val < -ATTITUDE_PITCH_LIMIT )
		val = -ATTITUDE_PITCH_LIMIT;

	val = val + attitude_comp;

	return val;
}
//---------------------------------------------------------------------------
FLOAT64	FSAPI	attitude_pitch_limit_night_sprite(PELEMENT_SPRITE pelement)
{

	FLOAT64 val=pelement->source_var_y.var_value.n;

	if( val > ATTITUDE_PITCH_LIMIT )
		val =  ATTITUDE_PITCH_LIMIT;
	else if( val < -ATTITUDE_PITCH_LIMIT )
		val = -ATTITUDE_PITCH_LIMIT;

	val = val + attitude_comp;

	return val;
}

//---------------------------------------------------------------------------
void FSAPI	attitude_update (PGAUGEHDR pgauge, int service_id, UINT32 extra_data)
{
	switch(service_id)
	{

/* "install_routine()" */

		case    PANEL_SERVICE_PRE_INSTALL:
		break;

/* "initialize_routine()" */

		case    PANEL_SERVICE_PRE_INITIALIZE:
		break;

/* "update_routine()" */

		case    PANEL_SERVICE_PRE_UPDATE:


//Day - night

		lookup_var(&avlights);
		if (avlights.var_value.n != 0) attitude_lights_on = 1;
		else attitude_lights_on = 0;

		if (attitude_lights_on == 1)
		{
			SHOW_LISTELEMENT(pgauge->elements_list[0],1);
			SHOW_LISTELEMENT(pgauge->elements_list[0],2);
			SHOW_LISTELEMENT(pgauge->elements_list[0],3);
			HIDE_LISTELEMENT(pgauge->elements_list[0],4);
			HIDE_LISTELEMENT(pgauge->elements_list[0],5);
			HIDE_LISTELEMENT(pgauge->elements_list[0],6);
		}
		else
		{
			SHOW_LISTELEMENT(pgauge->elements_list[0],4);
			SHOW_LISTELEMENT(pgauge->elements_list[0],5);
			SHOW_LISTELEMENT(pgauge->elements_list[0],6);
			HIDE_LISTELEMENT(pgauge->elements_list[0],1);
			HIDE_LISTELEMENT(pgauge->elements_list[0],2);
			HIDE_LISTELEMENT(pgauge->elements_list[0],3);
		}


		break;

/* "draw_routine()" */

		case    PANEL_SERVICE_PRE_DRAW:
		break;

/* "kill_routine()" */

		case    PANEL_SERVICE_PRE_KILL:
		break;
	}

}

/////////////////////////////////////////////////////////////////////////////
#undef GAUGE_NAME
#undef GAUGEHDR_VAR_NAME
#undef GAUGE_W

