//REPLACE vsi WITH GAUGENAME

char vsi_gauge_name[]		= GAUGE_NAME;
extern PELEMENT_HEADER		vsi_list;
extern MOUSERECT			vsi_mouse_rect[];
GAUGE_CALLBACK				vsi_update;
GAUGE_HEADER_FS700(GAUGE_W, vsi_gauge_name, &vsi_list, vsi_mouse_rect, vsi_update, 0,0,0 );

FAILURE_RECORD	vsi_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_ZERO},
	{FAIL_NONE, FAIL_ACTION_NONE}
};

MOUSE_BEGIN( vsi_mouse_rect, 0, 0, 0 )
MOUSE_END

#define GAUGE_MAX_FPM 4000
#define GAUGE_MIN_FPM -4000

//vsi indication

NONLINEARITY  vsi_needle_nl[] =

{
	{{289,	 178},	 -4000,   0},
	{{282,	 208},	 -3500,   0},
	{{265,	 236},	 -3000,   0},
	{{231,	 269},	 -2500,   0},
	{{187,	 287},	 -2000,   0},
	{{124,	 268},	 -1500,   0},
	{{69,	 255},	 -1000,   0},
	{{47,	 230},	 -700,   0},
	{{39,	 210},	 -500,   0},
	{{30,	 190},	 -300,   0},
	{{28,	 167},	 -100,   0},
	{{29,	 158},	 0,   0},
	{{28,	 147},	 100,   0},
	{{32,	 124},	 300,   0},
	{{41,	 104},	 500,   0},
	{{51,	 84},	 700,   0},
	{{72,	 61},	 1000,   0},
	{{130,	 31},	 1500,   0},
	{{193,	 32},	 2000,   0},
	{{235,	 52},	 2500,   0},
	{{268,	 85},	 3000,   0},
	{{283,	 112},	 3500,   0},
	{{285,	 145},	 4000,   0},
};

NONLINEARITY  vsi_needle_night_nl[] =

{
	{{289,	 178},	 -4000,   0},
	{{282,	 208},	 -3500,   0},
	{{265,	 236},	 -3000,   0},
	{{231,	 269},	 -2500,   0},
	{{187,	 287},	 -2000,   0},
	{{124,	 268},	 -1500,   0},
	{{69,	 255},	 -1000,   0},
	{{47,	 230},	 -700,   0},
	{{39,	 210},	 -500,   0},
	{{30,	 190},	 -300,   0},
	{{28,	 167},	 -100,   0},
	{{29,	 158},	 0,   0},
	{{28,	 147},	 100,   0},
	{{32,	 124},	 300,   0},
	{{41,	 104},	 500,   0},
	{{51,	 84},	 700,   0},
	{{72,	 61},	 1000,   0},
	{{130,	 31},	 1500,   0},
	{{193,	 32},	 2000,   0},
	{{235,	 52},	 2500,   0},
	{{268,	 85},	 3000,   0},
	{{283,	 112},	 3500,   0},
	{{285,	 145},	 4000,   0},
};

NEEDLE_UPDATE_CALLBACK	vsi_needle_src_cb;


MAKE_NEEDLE(	vsi_needle,
				VSI_BMP_NEEDLE,
				NULL,
				vsi_fail,
                transparent | erase | anti_alias,
				0,
				161, 161,
				26, 16,
				VERTICAL_SPEED,
                vsi_needle_src_cb,
				vsi_needle_nl,
				0 )

PELEMENT_HEADER		vsi_plist1[] =
{
	&vsi_needle.header,
	NULL
};


MAKE_NEEDLE(	vsi_needle_night,
				VSI_BMP_NEEDLE,
				&vsi_plist1,
				vsi_fail,
                transparent | erase | anti_alias | bright | hidden,
				0,
				161, 161,
				26, 16,
				VERTICAL_SPEED,
                vsi_needle_src_cb,
				vsi_needle_night_nl,
				0 )

PELEMENT_HEADER		vsi_plist2[] =
{
	&vsi_needle_night.header,
	NULL
};


MAKE_ICON(		vsi_face_night,
				VSI_BMP_FACE,
				&vsi_plist2,
				vsi_fail,
                transparent | erase | bright | hidden,
				0,
				26,28,
				MODULE_VAR_NONE, NULL,
				ICON_SWITCH_TYPE_SET_CUR_ICON,
				1,
				0,
				0 )

PELEMENT_HEADER		vsi_plist3[] =
{
	&vsi_face_night.header,
	NULL
};


MAKE_STATIC(	vsi_background,
				VSI_BMP_BACKGROUND,
				&vsi_plist3,
				vsi_fail,
                transparent | erase,
				0,
				{0, 0} )

PELEMENT_HEADER		vsi_list	= &vsi_background.header;


//---------------------------------------------------------------------------
FLOAT64 FSAPI vsi_needle_src_cb ( PELEMENT_NEEDLE pelement )

{
	FLOAT64 val=pelement->source_var.var_value.n /= 1.30048;

	if ( val > GAUGE_MAX_FPM ) val = GAUGE_MAX_FPM;
	if ( val < GAUGE_MIN_FPM ) val = GAUGE_MIN_FPM;

	return val;
}
//---------------------------------------------------------------------------
void FSAPI	vsi_update (PGAUGEHDR pgauge, int service_id, UINT32 extra_data)
{
	switch(service_id)
	{

/* "install_routine()" */

		case    PANEL_SERVICE_PRE_INSTALL:
		break;

/* "initialize_routine()" */

		case    PANEL_SERVICE_PRE_INITIALIZE:
		break;

/* "update_routine()" */

		case    PANEL_SERVICE_PRE_UPDATE:

//Night lighting

		lookup_var(&avlights);
		if (avlights.var_value.n != 0) vsi_lights_on = 1;
		else vsi_lights_on = 0;

		if (vsi_lights_on == 1)
		{
			SHOW_LISTELEMENT(pgauge->elements_list[0],1);
			SHOW_LISTELEMENT(pgauge->elements_list[0],2);
			HIDE_LISTELEMENT(pgauge->elements_list[0],3);
		}
		else
		{
			HIDE_LISTELEMENT(pgauge->elements_list[0],1);
			HIDE_LISTELEMENT(pgauge->elements_list[0],2);
			SHOW_LISTELEMENT(pgauge->elements_list[0],3);
		}

		break;

/* "draw_routine()" */

		case    PANEL_SERVICE_PRE_DRAW:
		break;

/* "kill_routine()" */

		case    PANEL_SERVICE_PRE_KILL:
		break;
	}

}

/////////////////////////////////////////////////////////////////////////////
#undef GAUGE_NAME
#undef GAUGEHDR_VAR_NAME
#undef GAUGE_W

