//SD3-60 throttle stack sub-gauge

char power_gauge_name[]		= GAUGE_NAME;
extern PELEMENT_HEADER		throttles_list;
extern MOUSERECT			throttles_mouse_rect[];
GAUGE_CALLBACK				throttles_update;
GAUGE_HEADER_FS700(GAUGE_W, throttles_gauge_name, &throttles_list, throttles_mouse_rect, throttles_update, 0,0,0 );

FAILURE_RECORD	throttles_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_ZERO},
	{FAIL_NONE, FAIL_ACTION_NONE}
};

MODULE_VAR lpos = {ENGINE1_THROTTLE_LEVER_POS};
MODULE_VAR rpos = {ENGINE2_THROTTLE_LEVER_POS};
MODULE_VAR aspeed = {AIRSPEED};
MODULE_VAR rpm1 = {ENGINE1_N2_RPM};
MODULE_VAR rpm2 = {ENGINE2_N2_RPM};

UINT32 asi = 0;				//Groundspeed
UINT32 arm_left_rtop = 0;	//RTOP armed on the overhead panel for the port engine
UINT32 arm_right_rtop = 0;	//Ditto starboard
UINT32 revs1 = 0;			//N2 on engine 1
UINT32 revs2 = 0;			//Ditto engine 2
UINT32 rtop_active = 0;		//Engine failed so RTOP system is active
UINT32 control_lock = 1;	//Restrict ground speed to MAX TAXI

//Special throttle checks

FILE *speed;				//Text file to read throttle power check
char rate[9];				//Input from file
UINT32 max_throttle;		//Maximum power derived from text file - requires stdio.h to read

UPDATE_MAKE_MOVING_CALLBACK	LeftX_var;
UPDATE_MAKE_MOVING_CALLBACK	RightX_var;
UPDATE_MAKE_MOVING_CALLBACK	dist_left_cb;
UPDATE_MAKE_MOVING_CALLBACK	dist_right_cb;

MOUSE_FUNCTION	power_plus_left;	//Mouse throttle lever functions
MOUSE_FUNCTION	power_plus_right;
MOUSE_FUNCTION	power_minus_left;
MOUSE_FUNCTION	power_minus_right;
MOUSE_FUNCTION	reverse_fwd_left;
MOUSE_FUNCTION	reverse_fwd_right;
MOUSE_FUNCTION	reverse_back_left;
MOUSE_FUNCTION	reverse_back_right;
MOUSE_FUNCTION	both_up;
MOUSE_FUNCTION	both_down;

MOUSE_BEGIN( mouse_rect, 0, 0, 0 )

        MOUSE_CHILD_FUNCT( 36, 54, 14, 70, CURSOR_UPARROW, MOUSE_LEFTSINGLE | MOUSE_DOWN_REPEAT, power_plus_left )
        MOUSE_CHILD_FUNCT( 61, 54, 14, 70, CURSOR_UPARROW, MOUSE_LEFTSINGLE | MOUSE_DOWN_REPEAT, power_plus_right )
        MOUSE_CHILD_FUNCT( 36, 124, 14, 65, CURSOR_DOWNARROW, MOUSE_LEFTSINGLE | MOUSE_DOWN_REPEAT, power_minus_left )
        MOUSE_CHILD_FUNCT( 61, 124, 14, 65, CURSOR_DOWNARROW, MOUSE_LEFTSINGLE | MOUSE_DOWN_REPEAT, power_minus_right )
        MOUSE_CHILD_FUNCT( 36, 171, 14, 12, CURSOR_UPARROW, MOUSE_LEFTSINGLE | MOUSE_DOWN_REPEAT, reverse_fwd_left )
        MOUSE_CHILD_FUNCT( 61, 171, 14, 12, CURSOR_UPARROW, MOUSE_LEFTSINGLE | MOUSE_DOWN_REPEAT, reverse_fwd_right )
        MOUSE_CHILD_FUNCT( 36, 184, 14, 12, CURSOR_DOWNARROW, MOUSE_LEFTSINGLE | MOUSE_DOWN_REPEAT, reverse_back_left )
        MOUSE_CHILD_FUNCT( 61, 184, 14, 12, CURSOR_DOWNARROW, MOUSE_LEFTSINGLE | MOUSE_DOWN_REPEAT, reverse_back_right )
        MOUSE_CHILD_FUNCT( 50, 40, 11, 65, CURSOR_HAND, MOUSE_LEFTSINGLE | MOUSE_DOWN_REPEAT, both_up )
        MOUSE_CHILD_FUNCT( 50, 106, 11, 65, CURSOR_HAND, MOUSE_LEFTSINGLE | MOUSE_DOWN_REPEAT, both_down )

MOUSE_END

MAKE_ICON(		unlock,
				BMP_UNLOCK,
				NULL,
				NULL,
				IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE | IMAGE_HIDDEN,
				0,
				47,10,
				MODULE_VAR_NONE, NULL,
				ICON_SWITCH_TYPE_SET_CUR_ICON,
				1,
				0,
				0, )

PELEMENT_HEADER		throttles_plist1[] =
{
	&unlock.header,
	NULL
};

MAKE_MOVING(	left,
				BMP_LKNOB,
				&throttles_plist1,
				NULL,
				IMAGE_USE_ERASE | IMAGE_USE_TRANSPARENCY,
				0,
				12,40,
				MODULE_VAR_NONE, LeftX_var,
				0, 0,
				MODULE_VAR_NONE, dist_left_cb,
				12288, -1638)

PELEMENT_HEADER		throttles_plist2[] =
{
	&left.header,
	NULL
};

MAKE_MOVING(	right,
				BMP_RKNOB,
				&throttles_plist2,
				NULL,
				IMAGE_USE_ERASE | IMAGE_USE_TRANSPARENCY,
				0,
				60,40,
				MODULE_VAR_NONE, RightX_var,
				0, 0,
				MODULE_VAR_NONE, dist_right_cb,
				12288, -1638)

PELEMENT_HEADER		throttles_plist3[] =
{
	&right.header,
	NULL
};

MAKE_ICON(		dummy_left,
				BMP_LKNOB,
				&throttles_plist3,
				NULL,
				IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE | IMAGE_HIDDEN,
				0,
				12,40,
				MODULE_VAR_NONE, NULL,
				ICON_SWITCH_TYPE_SET_CUR_ICON,
				1,
				0,
				0, )

PELEMENT_HEADER		throttles_plist4[] =
{
	&dummy_left.header,
	NULL
};

MAKE_ICON(		dummy_right,
				BMP_RKNOB,
				&throttles_plist4,
				NULL,
				IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE | IMAGE_HIDDEN,
				0,
				60,40,
				MODULE_VAR_NONE, NULL,
				ICON_SWITCH_TYPE_SET_CUR_ICON,
				1,
				0,
				0, )

PELEMENT_HEADER		throttles_plist5[] =
{
	&dummy_right.header,
	NULL
};

MAKE_ICON(		lock,
				BMP_LOCK,
				&throttles_plist5,
				NULL,
				IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
				0,
				47,10,
				MODULE_VAR_NONE, NULL,
				ICON_SWITCH_TYPE_SET_CUR_ICON,
				1,
				0,
				0, )

PELEMENT_HEADER		throttles_plist6[] =
{
	&lock.header,
	NULL
};



MAKE_STATIC( 	background,
				BMP_BACKGROUND,
				&throttles_plist6,
				NULL,
				IMAGE_USE_TRANSPARENCY,
				0,
				{0,0} )

PELEMENT_HEADER		throttles_list	= &background.header;

//---------------------------------------------------------------------------
FLOAT64 FSAPI	LeftX_var(PELEMENT_MOVING_IMAGE pelement)
{
	return 1.0;  //Dummy callback
}
//---------------------------------------------------------------------------
FLOAT64 FSAPI	RightX_var(PELEMENT_MOVING_IMAGE pelement)
{
	return 1.0;  //Dummy callback
}
//---------------------------------------------------------------------------

BOOL FSAPI both_up ( PPIXPOINT relative_point, FLAGS32 mouse_flags )
{

//Mouse call both throttles to full allowed power (max_throttle) 
//If control locks are active then restrict power to MAX_TAXI

	lookup_var(&lpos);
	if (control_lock == 1)
	{
		if (lpos.var_value.n < 5500)
		{
			trigger_key_event(KEY_THROTTLE1_INCR,0);
		}
		if (rpos.var_value.n < 5500)
		{
			trigger_key_event(KEY_THROTTLE2_INCR,0);
		}
	}
	else
	{
		if (lpos.var_value.n < max_throttle)
		{
			trigger_key_event(KEY_THROTTLE1_INCR,0);
		}

		if (rpos.var_value.n < max_throttle)
		{
			trigger_key_event(KEY_THROTTLE2_INCR,0);
		}
	}
	return FALSE;
}
//---------------------------------------------------------------------------

BOOL FSAPI both_down ( PPIXPOINT relative_point, FLAGS32 mouse_flags )
{

//Mouse call both throttles down together to idle

	lookup_var(&lpos);
	lookup_var(&rpos);

	if (lpos.var_value.n > 0)
	{
		trigger_key_event(KEY_THROTTLE1_DECR,0);
	}
	if (rpos.var_value.n > 0)
	{
		trigger_key_event(KEY_THROTTLE2_DECR,0);
	}
	return FALSE;
}
//---------------------------------------------------------------------------

BOOL FSAPI power_plus_left ( PPIXPOINT relative_point, FLAGS32 mouse_flags )
{

//Mouse call left throttle to full allowed power (max_throttle) 
//If control locks are active then restrict power to MAX_TAXI

	lookup_var(&lpos);
	if (control_lock == 1)
	{
		if (lpos.var_value.n < 5500)
		{
			trigger_key_event(KEY_THROTTLE1_INCR,0);
		}
	}
	else
	if (lpos.var_value.n < max_throttle)
	{
		trigger_key_event(KEY_THROTTLE1_INCR,0);
	}
	return FALSE;
}
//---------------------------------------------------------------------------

BOOL FSAPI power_plus_right( PPIXPOINT relative_point, FLAGS32 mouse_flags )
{

//Mouse call right throttle to full allowed power (max_throttle) 
//If control locks are active then restrict power to MAX_TAXI

	lookup_var(&rpos);
	if (control_lock == 1)
	{
		if (rpos.var_value.n < 5500)
		{
			trigger_key_event(KEY_THROTTLE2_INCR,0);
		}
	}
	else
	if (rpos.var_value.n < max_throttle)
	{
		trigger_key_event(KEY_THROTTLE2_INCR,0);
	}
	return FALSE;
}
//---------------------------------------------------------------------------

BOOL FSAPI power_minus_left ( PPIXPOINT relative_point, FLAGS32 mouse_flags )
{

//Mouse call left throttle to idle

	lookup_var(&lpos);
	if (lpos.var_value.n > 0)
	{
		trigger_key_event(KEY_THROTTLE1_DECR,0);
	}
	return FALSE;
}
//---------------------------------------------------------------------------

BOOL FSAPI power_minus_right( PPIXPOINT relative_point, FLAGS32 mouse_flags )
{

//Mouse call right throttle to idle

	lookup_var(&rpos);
	if (rpos.var_value.n > 0)
	{
		trigger_key_event(KEY_THROTTLE2_DECR,0);
	}
	return FALSE;
}
//---------------------------------------------------------------------------

BOOL FSAPI reverse_fwd_left ( PPIXPOINT relative_point, FLAGS32 mouse_flags )
{

//Mouse call left throttle back to idle from reverse

	lookup_var(&lpos);
	if (lpos.var_value.n < 0)
	{
		trigger_key_event(KEY_THROTTLE1_INCR,0);
	}
	return FALSE;
}
//---------------------------------------------------------------------------

BOOL FSAPI reverse_fwd_right( PPIXPOINT relative_point, FLAGS32 mouse_flags )
{

//Mouse call right throttle back to idle from reverse

	lookup_var(&rpos);
	if (rpos.var_value.n < 0)
	{
		trigger_key_event(KEY_THROTTLE2_INCR,0);
	}
	return FALSE;
}
//---------------------------------------------------------------------------

BOOL FSAPI reverse_back_left ( PPIXPOINT relative_point, FLAGS32 mouse_flags )
{

//Mouse call left throttle to reverse thrust

	lookup_var(&lpos);
	if (lpos.var_value.n > -1638)
	{
		trigger_key_event(KEY_THROTTLE1_DECR,0);
	}
	return FALSE;
}
//---------------------------------------------------------------------------

BOOL FSAPI reverse_back_right( PPIXPOINT relative_point, FLAGS32 mouse_flags )
{

//Mouse call right throttle to reverse thrust

	lookup_var(&rpos);
	if (rpos.var_value.n > -1638)
	{
		trigger_key_event(KEY_THROTTLE2_DECR,0);
	}
	return FALSE;
}

//--------------------------------------------------------------

FLOAT64 FSAPI dist_left_cb(PELEMENT_MOVING_IMAGE pelement)
{

//Check position of left throttles from joystick/keyboard input

	lookup_var(&lpos);
	return lpos.var_value.n;
}
//--------------------------------------------------------------

FLOAT64 FSAPI dist_right_cb(PELEMENT_MOVING_IMAGE pelement)
{

//Check position of right throttles from joystick/keyboard input

	lookup_var(&rpos);
	return rpos.var_value.n;
}

//---------------------------------------------------------------------------
void FSAPI throttles( PGAUGEHDR pgauge, int service_id, UINT32 extra_data )
{
   switch(service_id)
   {
    case    PANEL_SERVICE_PRE_INSTALL:
	break;

    case    PANEL_SERVICE_PRE_INITIALIZE:
	break;

    case    PANEL_SERVICE_PRE_UPDATE:

	lookup_var(&lpos);			//Left throttle position
	lookup_var(&rpos);			//Right throttle position
	lookup_var(&aspeed);		//Current airspeed indicated
	lookup_var(&rpm1);			//Left engine N2
	lookup_var(&rpm2);			//Right engine N2
	revs1 = rpm1.var_value.n;
	revs2 = rpm2.var_value.n;
	asi = aspeed.var_value.n;

//Control locks active then show lever forward

	if (control_lock == 1)
	{
		SHOW_LISTELEMENT(pgauge->elements_list[0],1);
		HIDE_LISTELEMENT(pgauge->elements_list[0],6);
	}
	else
	{
		SHOW_LISTELEMENT(pgauge->elements_list[0],6);
		HIDE_LISTELEMENT(pgauge->elements_list[0],1);
	}

//Engine failure - if RTOP is armed then hit RTOP for OPPOSITE engine and light warning EI
//Declare RTOP active and push throttles to full FS power

	if (revs1 < 3000 && arm_left_rtop == 1 && asi > 50)
	{
		right_engine_fail = 1;
		trigger_key_event(KEY_THROTTLE1_FULL, 0);
		rtop_active = 1;
	}
	else
	if (revs2 < 3000 && arm_right_rtop == 1 && asi > 50)
	{
		left_engine_fail = 1;
		trigger_key_event(KEY_THROTTLE2_FULL, 0);
		rtop_active = 1;
	}
	else
	{
		left_engine_fail = 0;
		right_engine_fail = 0;
		rtop_active = 0;
	}

//Keep throttle below max to allow headroom for RTOP and more realistic power delivery
//For greater realism separate the throttles but for general FS use it probably won't matter

	if (rtop_active == 0 && (lpos.var_value.n > max_throttle || rpos.var_value.n > max_throttle ))
	{
		trigger_key_event(KEY_THROTTLE_SET, max_throttle);
	}

//Hide moving throttles if RTOP goes active or pilot hits F4

	if (lpos.var_value.n > max_throttle)
	{
		SHOW_LISTELEMENT(pgauge->elements_list[0],3);
		HIDE_LISTELEMENT(pgauge->elements_list[0],5);
	}
	else
	{
		SHOW_LISTELEMENT(pgauge->elements_list[0],5);
		HIDE_LISTELEMENT(pgauge->elements_list[0],3);
	}

	if (rpos.var_value.n > max_throttle)
	{
		SHOW_LISTELEMENT(pgauge->elements_list[0],2);
		HIDE_LISTELEMENT(pgauge->elements_list[0],4);
	}
	else
	{
		SHOW_LISTELEMENT(pgauge->elements_list[0],4);
		HIDE_LISTELEMENT(pgauge->elements_list[0],2);
	}

//Stop throttles if keyboard or joystick throttle control is used during taxi

	if (lpos.var_value.n > 5500 && control_lock == 1)
	{
		trigger_key_event(KEY_THROTTLE1_SET,5500);
	}

	if (rpos.var_value.n > 5500 && control_lock == 1)
	{
		trigger_key_event(KEY_THROTTLE2_SET,5500);
	}


//Special text file for throttle checks to set max_throttle

	speed = fopen("throttle.dat","r");
	{
		if (fgets(rate,9,speed) != NULL);
	}
	fclose(speed);
	max_throttle = atoi(rate);

	break;

    case    PANEL_SERVICE_PRE_DRAW:
	break;

    case    PANEL_SERVICE_PRE_KILL:
	break;

    }
}
//-----------------------------------------------------------------
#undef GAUGE_NAME
#undef GAUGEHDR_VAR_NAME
#undef GAUGE_W
